﻿/*********************************************************
 *********************************************************
 ******	  Parampal Randhawa (AKA Param), India		******
 ******   Flapshot - Air Application				******
 ******	  Sheridan College, Canada					******
 ******   March 8, 2008							    ******
 *********************************************************
 ********************************************************/
 
package flapshot {
	
	import flash.display.MovieClip;
	import flash.events.*
	import fl.controls.Button;
	import flash.ui.Keyboard;
	
	import fl.video.VideoPlayer;
	
	//PNG encoder
	//import flash.geom.*;
	import flash.utils.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	import fl.data.DataProvider;
	//import fl.controls.dataGridClasses.DataGridColumn;
		
	// air packages
	// files	
	import flash.desktop.Clipboard;
    import flash.desktop.ClipboardFormats;
    import flash.desktop.ClipboardTransferMode;
    import flash.desktop.NativeDragManager;
    import flash.events.NativeDragEvent;
    import flash.filesystem.File;
	import flash.desktop.NativeApplication;
	import flash.filesystem.FileStream;
	import flash.filesystem.FileMode;
	//import flash.filesystem.*;
		
	// full screen
	import flash.display.StageScaleMode;
	import flash.display.StageDisplayState;
	//import flash.system.Capabilities;
	//import flash.display.NativeWindow;
	//import flash.display.NativeWindowDisplayState;		
	
	public class Flapshot extends MovieClip {
		
		// AIR Variables
		
		// file variables
		private var myFile:String;
		private var myFileList:Array;
		private var myFileNum:Number;		
		private var myTempFile:String;		
		private var myTempFileList:Array;
		private var myTempFileNum:Number;
		private var myExtensions:Array = ["flv"];		
		
		// fullscreen variables
		private var fullCheck:Boolean = false;
		private var preFullX:Number;
		private var preFullY:Number;
		private var preFullW:Number;
		private var preFullH:Number;
		private var preFullType:String;
		private var chromeEdge:Number;
		private var chromeTop:Number		
						
		private var newFile:int;
		private var fileNameStr:String;
				
		public function Flapshot() {		
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, myKeyDown);
			
			// AIR events and stuff
           
			// see if they have dropped a file on the application icon 
			NativeApplication.nativeApplication.addEventListener(InvokeEvent.INVOKE, myInvoke);   
		   
			// check to see stuff dragged onto the ball			
			window.myDropBox.addEventListener(NativeDragEvent.NATIVE_DRAG_ENTER, myDragEnter);
   			window.myDropBox.addEventListener(NativeDragEvent.NATIVE_DRAG_DROP, myDragDrop);
			window.myDropBox.addEventListener(NativeDragEvent.NATIVE_DRAG_EXIT, myDragExit);
			
			window.titleBar.addEventListener(MouseEvent.MOUSE_DOWN, dragStart);
			window.titleBar.addEventListener(MouseEvent.MOUSE_UP, dragStop);
			window.titleBar.btnClose.buttonMode = true;
			window.titleBar.btnMinimize.buttonMode = true;
			window.titleBar.btnClose.addEventListener(MouseEvent.MOUSE_UP, windowClose);			
			window.titleBar.btnMinimize.addEventListener(MouseEvent.MOUSE_UP, windowMinimize);
			
			stage.nativeWindow.maximize();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			// fullscreen calculations
			chromeEdge = (stage.nativeWindow.width - stage.stageWidth) / 2;
			chromeTop = stage.nativeWindow.height - stage.stageHeight - chromeEdge;				
			
			window.butPrev.enabled = false;
			window.butNext.enabled = false;
			window.butFullScr.enabled = false;
			window.butSnap.enabled = false;
			
			//smooth video playback
			var videoplayer:VideoPlayer = window.myFLV.getVideoPlayer(0);
			videoplayer.smoothing = true;
			window.myFLV.addEventListener(Event.COMPLETE, nextVideo);
			
			
		}
		
		
		// -------  event methods to handle dropping of files on application icon and window (AIR)
	
		private function myInvoke(e:InvokeEvent):void {
			trace("invoke");
			if (e.arguments.length > 0) {
				var myArray:Array = [];
				// turn the array of strings into File objects 
				for(var i:uint=0; i<e.arguments.length; i++) {
					myArray.push(new File(e.arguments[i]));
				}
				if (getFiles(myArray)) {
					loadMyFile();
				}
			}							
		}
		
		private function myDragEnter(e:NativeDragEvent) {			
			// casting as Array(myData...) does not work because Array() is a global function
			var myArray:Array = e.clipboard.getData(ClipboardFormats.FILE_LIST_FORMAT) as Array;

			if (getFiles(myArray)) {
				// need to call this to accept the drop					
				NativeDragManager.acceptDragDrop(window.myDropBox);
			}
		}		
		
		private function myDragDrop(e:NativeDragEvent) {						
			loadMyFile();			
		}		
		
		private function myDragExit(e:NativeDragEvent) {
			trace ("drag exit");
		}
		
		// -------  methods to get the file list (AIR)
		
		// prepares a temporary list of files from an array of filenames
		// if the array has one file, the files in the directory are collected
		// this temporary list will get applied when the file (or files) is dropped
		
		private function getFiles(myArray) {
			myTempFileList = [];		
			var i:uint;
			for(i=0; i<myArray.length; i++) {
				var file:File = myArray[i];
				if (file.isDirectory) {continue;}
				if (myExtensions.indexOf(file.extension.toLowerCase()) != -1) {
					myTempFileList.push(file);					
				}								
			}			
			if (myTempFileList.length > 0) {
				myTempFile = myTempFileList[0].url
				myTempFileNum = 0;				
				if (myTempFileList.length == 1) {
					// get other files in directory
					myTempFileList = getDirectoryFiles(myTempFileList[0]);
				}						
				return true;
			} else {
				return false;
			}
		}
		
		private function getDirectoryFiles(f:File) {
			var directoryList:Array = f.parent.getDirectoryListing();		
			var addFiles:Array = [];
			var count = 0;
			for (var i:uint=0; i<directoryList.length; i++) {
				var file:File = directoryList[i];				
				if (file.isDirectory) {continue;}
				//if it does not exits in the array then -1 would be returned
				if (myExtensions.indexOf(file.extension.toLowerCase()) != -1) {
					if (f.url == file.url) {
						myTempFileNum = count;
					}
					addFiles.push(file);
					count++;
				}				
			}
			return addFiles;
		}		

		// -------  plain old loader, buttons and accessing an array for the file 		
		private function loadMyFile() {
			myFileList = myTempFileList;
			myFile = myTempFile;					
			myFileNum = myTempFileNum;
			
			window.myFLV.source = myFile;
			window.myFLV.play();
			
			
			if (myFileList.length > 1) {
				window.butPrev.enabled = true;
				window.butNext.enabled = true;
				window.butFullScr.enabled = true;
				window.butSnap.enabled = true;
				window.butPrev.addEventListener(MouseEvent.CLICK, prevFile);
				window.butNext.addEventListener(MouseEvent.CLICK, nextFile);
				window.butFullScr.addEventListener(MouseEvent.CLICK, fullScr);
				window.butSnap.addEventListener(MouseEvent.CLICK, takeSnapshot);
			}
			
			
			//-----------------------Data Grid--------------------------------
			
			var myDataProvider:Array = [];
			var temp:Array = [];
			
			for (var i:uint=0; i<myFileList.length; i++) {				
				temp = myFileList[i].url.split("/");
				//trace(temp[temp.length - 1]);			
				myDataProvider.push({flvList:temp[temp.length - 1], flvPath:myFileList[i].url});				
				//trace(myFileList[i].url);
			}			
			
			/*var flvListDGC:DataGridColumn = new DataGridColumn("flvList");
			var flvPathDGC:DataGridColumn = new DataGridColumn("flvPath");			
			myDataGrid.addColumn(flvListDGC);
			myDataGrid.addColumn(flvPathDGC);*/
			
			window.myDataGrid.columns = ["flvList", "flvPath"];
			window.myDataGrid.dataProvider = new DataProvider(myDataProvider);
			window.myDataGrid.getColumnAt(0).headerText = "FLV Video(s) List";
			window.myDataGrid.getColumnAt(1).visible = false;
			window.myDataGrid.addEventListener(Event.CHANGE, doDataGrid);
			gridHilight(myFileNum);
		}
		
		private function doDataGrid(e:Event) {
				
			window.myFLV.source = e.target.selectedItem.flvPath;
			window.myFLV.play();
		}
		
		//---------event handlers-------------------
		private function prevFile(e:MouseEvent) {			
			newFile = myFileNum - 1;
			if (newFile < 0) {
				newFile = myFileList.length-1;
			}
			playFLV();
			gridHilight(newFile);
		}
		
		private function nextFile(e:MouseEvent) {
			nextVidFile();
		}
		
		private function nextVideo(e:Event) {			
			nextVidFile();			
		}
		
		private function nextVidFile(){			
			newFile = myFileNum + 1;
			if (newFile > myFileList.length-1) {
				newFile = 0;
			}			
			playFLV();
			gridHilight(newFile);			
		}
		
		private function playFLV(){			
			myFile = myFileList[newFile].url;
			myFileNum = newFile;
			//myLoader.load(new URLRequest(myFile));						
			window.myFLV.source = myFile;
			window.myFLV.play();
		}
		
		private function gridHilight(itemNum:int){
			
			window.myDataGrid.selectedIndex = itemNum;
		}
		
		//-------take snapshot-------------------------
		private var bmd:BitmapData;	
		private var bit:Bitmap;
		private var bitHolder:MovieClip = new MovieClip();
		
		private var folder:String;
		private var file:String;
		
		private function takeSnapshot(e:MouseEvent) {					
											//last two parameters for transparency
			bmd = new BitmapData(window.myFLV.width, window.myFLV.height, true, 0x00000000);
			// Draw the image currently in the video player and add it to the display list
			bmd.draw(window.myFLV);
			bit = new Bitmap(bmd);
			
			
			if (bitHolder.numChildren > 0) {
				//bitHolder = null;
				window.snap.removeChild(bitHolder);
				bitHolder = new MovieClip();				
			}
			
			/*if (snap.getChildByName(bit.name) != null) {
				snap.removeChild(getChildByName(bit.name));
			}*/
			
			/*if(bit.parent == snap) {
				snap.removeChild(bit);
			}*/
			trace(bitHolder.numChildren);
			bitHolder.addChild(bit);
			window.snap.addChild(bitHolder);
			
			//----specify folder naming
			folder = String(new Date().date + "-" + new Date().month + "-" + new Date().fullYear) ;
			file = String(new Date().time);
			fileNameStr = "Flapshot/" + folder + "/" + "flapshot" + file + ".png";
			
			var myPNG:ByteArray = PNGEnc(bmd);
			
		}
		
		//----------PNG Encoder---------------------
		//from http://www.kaourantin.net/2005/10/png-encoder-in-as3.html
		//with few modifications
		
		private function PNGEnc(img:BitmapData):ByteArray {
			// Create output byte array
			var png:ByteArray = new ByteArray();
			// Write PNG signature
			png.writeUnsignedInt(0x89504e47);
			png.writeUnsignedInt(0x0D0A1A0A);
			// Build IHDR chunk
			var IHDR:ByteArray = new ByteArray();
			IHDR.writeInt(img.width);
			IHDR.writeInt(img.height);
			IHDR.writeUnsignedInt(0x08060000); // 32bit RGBA
			IHDR.writeByte(0);
			writeChunk(png,0x49484452,IHDR);
			// Build IDAT chunk
			var IDAT:ByteArray= new ByteArray();
			
			//IDAT = img.getPixels(new Rectangle(0,0,img.width, img.height));
			for(var i:int=0;i < img.height;i++) {
				// no filter
				IDAT.writeByte(0);
				var p:uint;
				var j:int;
				if ( !img.transparent ) {
					for(j=0; j < img.width;j++) {
						p = img.getPixel(j,i);
						IDAT.writeUnsignedInt(
							uint(((p&0xFFFFFF) << 8)|0xFF));
					}
				} else {
					for(j=0; j < img.width; j++) {
						p = img.getPixel32(j,i);
						IDAT.writeUnsignedInt(uint(((p&0xFFFFFF)<< 8)|((p>>>24))));
											//uint(((p&0xFFFFFF) << 8)|(shr(p,24))));
					}
				}
			}
			IDAT.compress();
			writeChunk(png,0x49444154,IDAT);
			// Build IEND chunk
			writeChunk(png,0x49454E44,null);
			// return PNG
			return png;
		}
	
		private static var crcTable:Array;
		private static var crcTableComputed:Boolean = false;
	
		private function writeChunk(png:ByteArray, type:uint, data:ByteArray) {
			if (!crcTableComputed) {
				crcTableComputed = true;
				crcTable = [];
				var c:uint;
				for (var n:uint = 0; n < 256; n++) {
					c = n;
					for (var k:uint = 0; k < 8; k++) {
						if (c & 1) {
							c = uint(uint(0xedb88320) ^ uint(c >>> 1));
						} else {
							c = uint(c >>> 1);
						}
					}
					crcTable[n] = c;
				}
			}
			var len:uint = 0;
			if (data != null) {
				len = data.length;
			}
			png.writeUnsignedInt(len);
			var p:uint = png.position;
			png.writeUnsignedInt(type);
			
			//-------Saving of the file------
			if ( data != null ) {
				png.writeBytes(data);
				//pass the value to function to save to disk
				outFile(fileNameStr, png);
			}
			
			var e:uint = png.position;
			png.position = p;
			var d:uint = 0xffffffff;
			for (var i:int = 0; i < (e-p); i++) {
				d = uint(crcTable[
					(d ^ png.readUnsignedByte()) & 
					uint(0xff)] ^ uint(d >>> 8));
			}
			d = uint(d^uint(0xffffffff));
			png.position = e;
			png.writeUnsignedInt(d);
		}
		
		//------save file to disk----------
		private function outFile(fileName:String, pngData:ByteArray):void {
			
			// reference from http://livedocs.adobe.com/air/1/devappsflash/help.html?content=ByteArrays_2.html
			//and http://livedocs.adobe.com/labs/air/1/devappsflex/help.html?content=Filesystem_32.html
			
			var fileStream:FileStream = new FileStream();
			var outFile:File = File.desktopDirectory; // dest folder is desktop
			outFile = outFile.resolvePath(fileName);  // name of file to write
			/*fs.open(e.target as File, FileMode.WRITE);
			fs.writeBytes(bit);
			fs.close();*/ 	
							
			var outStream:FileStream = new FileStream(); 
			outStream.open(outFile, FileMode.WRITE); // open output file stream in WRITE mode
			outStream.writeBytes(pngData, 0, pngData.length); // write out the file
			outStream.close(); // close it
		}

		
		// -------  fullscreen command - not air specific
		
		// key presses do not work in fullscreen so an alternative is below
		
		private function fullScr(e:MouseEvent){
			fullScreen();
		}
		
		private function myKeyDown(e:KeyboardEvent) {			
			if ((e.keyCode == 70 && e.ctrlKey) || e.keyCode == Keyboard.F11) { // ctrl F or Fll
				fullScreen();
			} else if (fullCheck && e.keyCode == Keyboard.ESCAPE) {
				fullScreen();		
			}
		}
		
		private function fullScreen() {
			if (stage.displayState == StageDisplayState.NORMAL) {	
				stage.displayState = StageDisplayState.FULL_SCREEN;
			} else {
				stage.displayState = StageDisplayState.NORMAL;
			}
			//myFLV.fullScreenTakeOver = false; //to make the window fullscreen
		}
		
		//---events of the title bar---------
		private function dragStart(e:MouseEvent) {
			window.startDrag();			
		}
		
		private function dragStop(e:MouseEvent) {
			window.stopDrag();
		}		
		private function windowClose(e:MouseEvent) {
			stage.nativeWindow.close();
		}	
		private function windowMinimize(e:MouseEvent) {
			stage.nativeWindow.minimize();
		}
	}
	
}